/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getLogicalOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getLogicalOperationDispatcher. It contains of all the generic methods
    for getLogicalOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getLogicalOperationDispatcher_HXX
#define getLogicalOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getLogicalOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getLogicalOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getLogicalOperationDispatcher();
        virtual ~getLogicalOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getLogicalPreConditions( const Teamcenter::BusinessObject* obj, bool& boolValue, bool& isNull ) const;
        void getLogicalPreActions( const Teamcenter::BusinessObject* obj, bool& boolValue, bool& isNull ) const;
        void getLogicalBaseAction( const Teamcenter::BusinessObject* obj, bool& boolValue, bool& isNull ) const;
        void getLogicalPostActions( const Teamcenter::BusinessObject* obj, bool& boolValue, bool& isNull ) const;

        // Project 011450 changes
        void getLogicalPreConditions( METHOD_message_t*  msgData, logical* value, logical* isNull ) const;
        void getLogicalPreActions( METHOD_message_t*  msgData, logical* value, logical* isNull ) const;
        void getLogicalBaseAction( METHOD_message_t*  msgData, logical* value, logical* isNull ) const;
        void getLogicalPostActions( METHOD_message_t*  msgData, logical* value, logical* isNull ) const;

        void getLogical( const Teamcenter::BusinessObject* obj, bool& boolValue, bool& isNull ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getLogicalOperationDispatcher_HXX
